/*
This is an On Screen Keyboard.
It can be added to Xbase++ applications
*/

#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

FUNCTION Main()

LOCAL oOSK, GetList[0], cText := '', oText, oThread

oThread :=Thread():new()
Sleep(5)
oThread:start({||StartOSK( @oOsk )})

Sleep(100)

@ 0,0 DCSAY 'Enter some text:' SAYSIZE 0

@ 1,0 DCMULTILINE cText OBJECT oText SIZE 100,10 ;
      FONT '12.Lucida Console' RESIZE DCGUI_RESIZE_RESIZEONLY

@ 12,0 DCPUSHBUTTON ;
       CAPTION {||IIF(oOSK:isVisible(),'HIDE','SHOW') + ' OSK'} ;
       SIZE 10,1.2 ;
       ACTION {||IIF(oOSK:isVisible(),oOSK:hide(),oOSK:show()), ;
                 DC_GetRefresh(GetList)}

DCGETOPTIONS RESIZE

DCREAD GUI FIT HANDLER TouchHandler REFERENCE oOsk ;
   EVAL {||oOsk:targetXbp := oText} ;
   MODAL ;
   SETAPPWINDOW ;
   TITLE 'Testing OSK'

RETURN nil

* ------------

STATIC FUNCTION StartOSK( oOSK )

oOSK := TouchKeyboard():new()
oOSK:create()

RETURN nil

* ------------

STATIC FUNCTION TouchHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList, oOsk )

RETURN DCGUI_NONE

* ------------

PROC appsys ; RETURN

* ------------

CLASS TouchKeyboard

EXPORTED :
  VAR isFirstTime
  VAR isCapsLock
  VAR accumulator
  VAR buttonConfig
  VAR dialogWindow
  VAR getList
  VAR targetXbp
  VAR isVisible

  METHOD Init(), Create(), Accum(), Show(), Hide(), Destroy(), IsVisible()

ENDCLASS

* --------

METHOD TouchKeyboard:init()

::buttonConfig := DC_XbpPushButtonXPConfig():new()
::buttonConfig:fgColor := GRA_CLR_WHITE
::buttonConfig:bgColor := GRA_CLR_DARKCYAN
::buttonConfig:radius := 30
::buttonConfig:font := '34.Arial'
::isVisible := .f.

RETURN self

* ---------

METHOD TouchKeyboard:show()

IF Valtype(::dialogWindow) == 'O' .AND. ::dialogWindow:status() > 0
  ::dialogWindow:show()
  ::isVisible := .t.
ENDIF

RETURN self

* ----------

METHOD TouchKeyboard:hide()

IF Valtype(::dialogWindow) == 'O' .AND. ::dialogWindow:status() > 0
  ::dialogWindow:hide()
  ::isVisible := .f.
ENDIF

RETURN self

* ----------

METHOD TouchKeyboard:destroy()

IF Valtype(::dialogWindow) == 'O' .AND. ::dialogWindow:status() > 0
  ::dialogWindow:destroy()
  ::isVisible := .f.
ENDIF

RETURN self

* ----------

METHOD TouchKeyboard:isVisible()

RETURN ::isVisible

* --------

METHOD TouchKeyboard:create( cTitle )

LOCAL GetList := {}, GetOptions, cSaveValue, oCancelButton, lReturn := .t., ;
      nKeySize := 100, nSpace := 5, cFixedFont := '36.Lucida Console', cValue, ;
      nRow, lStatus, cTitleFont := '28.Arial', nMode

DCGETOPTIONS ;
   COLOR GRA_CLR_PALEGRAY ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   HIDE ;
   PIXEL

::isFirstTime := .t.
::isCapsLock := .f.
::accumulator := ''

cValue := Space(50)

::isCapslock := .F.

DEFAULT cTitle := "Touch Screen Keyboard"

nRow := 0

@ nRow,  0 DCPUSHBUTTONXP CAPTION {||IIF( ::isCapsLock,'!','1') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('1','!',@cValue,GetList)} ;
   ACCELKEY Asc('1') CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'@','2') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('2','@',@cValue,GetList)} ;
   ACCELKEY Asc('2')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'#','3') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('3','#',@cValue,GetList)} ;
   ACCELKEY Asc('3')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'$','4') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('4','$',@cValue,GetList)} ;
   ACCELKEY Asc('4')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'%','5') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('5','%',@cValue,GetList)} ;
   ACCELKEY Asc('5')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'^','6') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('6','^',@cValue,GetList)} ;
   ACCELKEY Asc('6')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,' &&','7') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('7','&',@cValue,GetList)} ;
   ACCELKEY Asc('7')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'*','8') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('8','*',@cValue,GetList)} ;
   ACCELKEY Asc('8')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'(','9') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('9','(',@cValue,GetList)} ;
   ACCELKEY Asc('9')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,')','0') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('0',')',@cValue,GetList)} ;
   ACCELKEY Asc('0')  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'_','-') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('-','_',@cValue,GetList)} ;
   ACCELKEY {Asc('-'),Asc('_')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'+','=') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('=','+',@cValue,GetList)} ;
   ACCELKEY {Asc('='),Asc('+')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION 'BS' SIZE nKeySize*2,nKeySize  ;
   ACTION {||::accum(Chr(xbeK_BS),'',@cValue,GetList)} ;
   ACCELKEY 8 CONFIG ::buttonConfig

nRow += nKeySize + nSpace

@ nRow, nKeySize/2 DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'Q','q') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('q','Q',@cValue,GetList)} ;
   ACCELKEY {Asc('q'),Asc('Q')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'W','w') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('w','W',@cValue,GetList)} ;
   ACCELKEY {Asc('w'),Asc('W')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'E','e') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('e','E',@cValue,GetList)} ;
   ACCELKEY {Asc('e'),Asc('E')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'R','r') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('r','R',@cValue,GetList)} ;
   ACCELKEY {Asc('r'),Asc('R')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'T','t') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('t','T',@cValue,GetList)} ;
   ACCELKEY {Asc('t'),Asc('T')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'Y','y') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('y','Y',@cValue,GetList)} ;
   ACCELKEY {Asc('y'),Asc('Y')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'U','u') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('u','U',@cValue,GetList)} ;
   ACCELKEY {Asc('u'),Asc('U')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'I','i') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('i','I',@cValue,GetList)} ;
   ACCELKEY {Asc('i'),Asc('I')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'O','o') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('o','O',@cValue,GetList)} ;
   ACCELKEY {Asc('o'),Asc('O')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'P','p') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('p','P',@cValue,GetList)} ;
   ACCELKEY {Asc('p'),Asc('P')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'{','[') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('[','{',@cValue,GetList)} ;
   ACCELKEY {Asc('['),Asc('{')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'}',']') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum(']','}',@cValue,GetList)} ;
   ACCELKEY {Asc(']'),Asc('}')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'|','\') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('\','|',@cValue,GetList)} ;
   ACCELKEY {Asc('\'),Asc('|')}  CONFIG ::buttonConfig

nRow += nKeySize + nSpace

@ nRow, nKeySize DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'A','a') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('a','A',@cValue,GetList)} ;
   ACCELKEY {Asc('a'),Asc('A')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'S','s') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('s','S',@cValue,GetList)} ;
   ACCELKEY {Asc('s'),Asc('S')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'D','d') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('d','D',@cValue,GetList)} ;
   ACCELKEY {Asc('d'),Asc('D')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'F','f') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('f','F',@cValue,GetList)} ;
   ACCELKEY {Asc('f'),Asc('F')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'G','g') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('g','G',@cValue,GetList)} ;
   ACCELKEY {Asc('g'),Asc('G')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'H','h') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('h','H',@cValue,GetList)} ;
   ACCELKEY {Asc('h'),Asc('H')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'J','j') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('j','J',@cValue,GetList)} ;
   ACCELKEY {Asc('j'),Asc('J')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'K','k') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('k','K',@cValue,GetList)} ;
   ACCELKEY {Asc('k'),Asc('K')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'L','l') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('l','L',@cValue,GetList)} ;
   ACCELKEY {Asc('l'),Asc('L')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,':',';;') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum(';',':',@cValue,GetList)} ;
   ACCELKEY {Asc(';'),Asc(':')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'"',"'") } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum("'",'"',@cValue,GetList)} ;
   ACCELKEY {Asc("'"),Asc('"')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'@',"@") } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum("@",'@',@cValue,GetList)} ;
   ACCELKEY {Asc("@"),Asc('@')}  CONFIG ::buttonConfig

nRow += nKeySize + nSpace

@ nRow, nKeySize*1.5 DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'Z','z') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('z','Z',@cValue,GetList)} ;
   ACCELKEY {Asc('z'),Asc('Z')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'X','x') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('x','X',@cValue,GetList)} ;
   ACCELKEY {Asc('x'),Asc('X')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'C','c') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('c','C',@cValue,GetList)} ;
   ACCELKEY {Asc('c'),Asc('C')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'V','v') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('v','V',@cValue,GetList)} ;
   ACCELKEY {Asc('v'),Asc('V')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'B','b') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('b','B',@cValue,GetList)} ;
   ACCELKEY {Asc('b'),Asc('B')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'N','n') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('n','N',@cValue,GetList)} ;
   ACCELKEY {Asc('n'),Asc('N')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'M','m') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('m','M',@cValue,GetList)} ;
   ACCELKEY {Asc('m'),Asc('M')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'<',',') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum(',','<',@cValue,GetList)} ;
   ACCELKEY {Asc(','),Asc('<')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'>','.') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('.','>',@cValue,GetList)} ;
   ACCELKEY {Asc('.'),Asc('>')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'?','/') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('/','?',@cValue,GetList)} ;
   ACCELKEY {Asc('/'),Asc('?')}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION 'CR' SIZE nKeySize*2,nKeySize  ;
   ACTION {||::accum(Chr(xbeK_ENTER),'',@cValue,GetList)} ;
   ACCELKEY 13 CONFIG ::buttonConfig

nRow += nKeySize + nSpace

@ nRow, 0 DCPUSHBUTTONXP CAPTION 'Caps' SIZE nKeySize*2,nKeySize  ;
   ACTION {|a,b,o|::isCapsLock:=!::isCapsLock, ;
   DC_GetRefresh(GetList)}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace  DCPUSHBUTTONXP CAPTION ' ' SIZE nKeySize*3.4,nKeySize  ;
   ACTION {||::accum(' ',' ',@cValue,GetList)} ;
   ACCELKEY 32  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'AOL','aol') } SIZE nKeySize, nKeySize  ;
   ACTION {||::accum('aol.com','AOL.COM',@cValue,GetList)} FONT {|| IIF( ::isCapsLock, '26.Arial', cTitleFont)};;
   CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'GMAIL','gmail') } SIZE nKeySize*1.3, nKeySize  ;
   ACTION {||::accum('gmail.com','GMAIL.COM',@cValue,GetList)} FONT {|| IIF( ::isCapsLock, '26.Arial', cTitleFont)};
   CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'YAHOO','yahoo') } SIZE nKeySize*1.4, nKeySize  ;
   ACTION {||::accum('yahoo.com','YAHOO.COM',@cValue,GetList)} FONT {|| IIF( ::isCapsLock, '26.Arial', cTitleFont)};
   CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION {||iif( ::isCapsLock,'.COM','.com') } SIZE nKeySize*1.2, nKeySize  ;
   ACTION {||::accum('.com','.COM',@cValue,GetList)} FONT {|| IIF( ::isCapsLock, '26.Arial', cTitleFont)};;
   CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION 'Caps' SIZE nKeySize*2,nKeySize  ;
   ACTION {|a,b,o|::isCapsLock:=!::isCapsLock, ;
   DC_GetRefresh(GetList)}  CONFIG ::buttonConfig

@ DCGUI_ROW, DCGUI_COL+nSpace DCPUSHBUTTONXP CAPTION 'EXIT' SIZE nKeySize*2,nKeySize  ;
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
   ACCELKEY 27 ;
   OBJECT oCancelButton  CONFIG ::buttonConfig

DCREAD GUI FIT ;
   TITLE cTitle ;
   SETFOCUS @oCancelButton ;
   TO lStatus ;
   OPTIONS GetOptions ;
   EVAL {|o|DC_CenterObject(o, SetAppWindow()), ;
            ::dialogWindow := o}

RETURN self

* ------------

METHOD TouchKeyboard:Accum ( cKey, cCapsKey )

LOCAL i, nKey

IF ::isCapsLock .AND. !Empty(cCapsKey)
  cKey := cCapsKey
ENDIF

FOR i := 1 TO Len(cKey)
  nKey := Asc(cKey[i])
  PostAppEvent( xbeP_Keyboard, nKey, , ::targetXbp )
NEXT

SetAppFocus(::targetXbp)

RETURN nil


